'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _timeout = require('../polyfill/timeout');

var _timeout2 = _interopRequireDefault(_timeout);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Audio;

module.exports = Audio = function () {
  function Audio(url) {
    var volume = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
    var needLoop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, Audio);

    this.url = url;
    this.volume = volume;
    this.needLoop = needLoop;
    this.audio = new window.Audio(this.url);
    this.audio.volume = this.volume;
    this.playing = false;
    this.needPlay = false;
    this.play();
    return;
  }

  _createClass(Audio, [{
    key: 'play',
    value: function play() {
      var _this = this;

      if (this.needLoop === true) {
        this.audio.loop = true;
      } else if (typeof this.needLoop === 'number') {
        this.audio.loop = true;
        this.loopTimeout = (0, _timeout2.default)(this.needLoop, function () {
          return _this.stop();
        });
      }
      this.audio.onplaying = function () {
        return _this.playing = true;
      };
      this.audio.onpause = function () {
        return _this.playing = false;
      };
      this.audio.play();
    }
  }, {
    key: 'stop',
    value: function stop() {
      this.audio.pause();
    }
  }]);

  return Audio;
}();