'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Cookies;

  module.exports = Cookies = function () {
    var deleteCookie;

    var Cookies = function () {
      function Cookies() {
        _classCallCheck(this, Cookies);
      }

      _createClass(Cookies, null, [{
        key: 'get',
        value: function get(name) {
          var matches;
          matches = document.cookie.match(new RegExp('(?:^|; )' + name.replace(/([.$?*|{}()\[\]\\\/+^])/g, '\\$1') + '=([^;]*)'));
          if (matches) {
            return decodeURIComponent(matches[1]);
          } else {
            return void 0;
          }
        }
      }, {
        key: 'set',
        value: function set(name, value) {
          var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

          var date, expires, propName, propValue, updatedCookie;
          options.path || (options.path = '/');
          expires = options.expires;
          if (expires && typeof expires === 'number') {
            date = new Date();
            date.setTime(date.getTime() + expires * 1000);
            expires = options.expires = date;
          }
          if (expires instanceof Date) {
            options.expires = expires.toUTCString();
          }
          updatedCookie = name + '=' + encodeURIComponent(value);
          for (propName in options) {
            updatedCookie += '; ' + propName;
            propValue = options[propName];
            if (propValue !== true) {
              updatedCookie += '=' + propValue;
            }
          }
          document.cookie = updatedCookie;
        }
      }]);

      return Cookies;
    }();

    ;

    Cookies.remove = deleteCookie = function deleteCookie(name) {
      this.set(name, '', {
        expires: -1
      });
    };

    return Cookies;
  }();
}).call(undefined);