"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var LocalStorage;

  module.exports = LocalStorage = function () {
    function LocalStorage() {
      _classCallCheck(this, LocalStorage);
    }

    _createClass(LocalStorage, null, [{
      key: "set",
      value: function set(key, value) {
        try {
          localStorage.setItem(key, JSON.stringify(value));
        } catch (error) {
          return false;
        }
        return false;
      }
    }, {
      key: "get",
      value: function get(key) {
        try {
          return JSON.parse(localStorage.getItem(key));
        } catch (error) {
          return void 0;
        }
      }
    }, {
      key: "remove",
      value: function remove(key) {
        return delete localStorage[key];
      }
    }]);

    return LocalStorage;
  }();
}).call(undefined);