"use strict";

(function () {
  var EventEmitter, SystemPromise, UiJsPromise;

  EventEmitter = require('./event-emitter');

  SystemPromise = window.Promise;

  module.exports = UiJsPromise = function UiJsPromise(caller) {
    var _reject, _resolve, promise;
    _resolve = null;
    _reject = null;
    promise = new SystemPromise(function (resolve, reject) {
      _resolve = resolve;
      _reject = reject;
      return typeof caller === "function" ? caller(resolve, reject) : void 0;
    });
    promise.resolve = _resolve;
    promise.reject = _reject;
    return promise;
  };

  UiJsPromise.prototype = SystemPromise.prototype;

  UiJsPromise.all = function () {
    var _SystemPromise;

    return (_SystemPromise = SystemPromise).all.apply(_SystemPromise, arguments);
  };

  UiJsPromise.race = function () {
    var _SystemPromise2;

    return (_SystemPromise2 = SystemPromise).race.apply(_SystemPromise2, arguments);
  };

  UiJsPromise.race = function () {
    var _SystemPromise3;

    return (_SystemPromise3 = SystemPromise).race.apply(_SystemPromise3, arguments);
  };

  UiJsPromise.defer = function () {
    var _SystemPromise4;

    return (_SystemPromise4 = SystemPromise).defer.apply(_SystemPromise4, arguments);
  };

  UiJsPromise.accept = function () {
    var _SystemPromise5;

    return (_SystemPromise5 = SystemPromise).accept.apply(_SystemPromise5, arguments);
  };

  UiJsPromise.reject = function () {
    var _SystemPromise6;

    return (_SystemPromise6 = SystemPromise).reject.apply(_SystemPromise6, arguments);
  };

  UiJsPromise.resolve = function () {
    var _SystemPromise7;

    return (_SystemPromise7 = SystemPromise).resolve.apply(_SystemPromise7, arguments);
  };
}).call(undefined);