'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var DOM, If, Tree;

  Tree = require('../core/tree');

  DOM = require('../dom');

  module.exports = If = function () {
    var If = function () {
      _createClass(If, null, [{
        key: 'compile',
        value: function compile(template, tree) {
          var comment, exp, subTree;
          comment = DOM.createComment(' *if ');
          tree.replace(comment);
          exp = template.attr('*if');
          template.removeAttr('*if');
          subTree = tree.create(template);
          return [subTree, exp];
        }
      }]);

      function If(label, component, scope, subThree, exp1) {
        _classCallCheck(this, If);

        this.changeState = this.changeState.bind(this);
        this.label = label;
        this.component = component;
        this.scope = scope;
        this.subThree = subThree;
        this.exp = exp1;
        this.node = null;
        this.watcher = ui.watch(this.component, this.exp, this.changeState, this.scope);
        this.isDebug = this.exp.indexOf('!activeRange.filterCar') !== -1;
        return;
      }

      _createClass(If, [{
        key: 'destructor',
        value: function destructor() {
          this.watcher.destroy();
        }
      }, {
        key: 'changeState',
        value: function changeState(state) {
          if (state) {
            this.create();
          } else {
            this.destroy();
          }
        }
      }, {
        key: 'create',
        value: function create() {
          if (this.node) {
            return;
          }
          this.node = this.subThree.template.clone();
          this.label.after(this.node);
          this.subThree.init(this.node, this.component, this.scope);
        }
      }, {
        key: 'destroy',
        value: function destroy() {
          if (!this.node) {
            return;
          }
          this.node.remove(true);
          this.node = null;
        }
      }]);

      return If;
    }();

    ;

    If.attribute = 'if';

    If.priority = 600;

    If.terminal = true;

    return If;
  }();
}).call(undefined);