'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Map, MutationObserver;

  Map = require('../../polyfill/map');

  module.exports = MutationObserver = function () {
    function MutationObserver() {
      _classCallCheck(this, MutationObserver);

      this.clearMutations = this.clearMutations.bind(this);
      this.hasMutations = this.hasMutations.bind(this);
      this.getMutations = this.getMutations.bind(this);
      this.mutate = this.mutate.bind(this);
      this.mutations = new Map();
      return;
    }

    _createClass(MutationObserver, [{
      key: 'clearMutations',
      value: function clearMutations() {
        this.mutations = new Map();
      }
    }, {
      key: 'hasMutations',
      value: function hasMutations() {
        return !!this.mutations.size;
      }
    }, {
      key: 'getMutations',
      value: function getMutations() {
        var mutations;
        mutations = this.mutations;
        this.clearMutations();
        return mutations;
      }
    }, {
      key: 'mutate',
      value: function mutate(node, type) {
        var nodeMutations;
        if (!this.mutations.has(node)) {
          this.mutations.set(node, {});
        }
        nodeMutations = this.mutations.get(node);
        nodeMutations[type] = true;
      }
    }]);

    return MutationObserver;
  }();
}).call(undefined);