'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(function () {
  var Element, Textarea;

  Element = require('./element');

  module.exports = Textarea = function () {
    var Textarea = function (_Element) {
      _inherits(Textarea, _Element);

      function Textarea() {
        _classCallCheck(this, Textarea);

        var _this = _possibleConstructorReturn(this, (Textarea.__proto__ || Object.getPrototypeOf(Textarea)).apply(this, arguments));

        _this.value_ = '';
        return _possibleConstructorReturn(_this);
      }

      _createClass(Textarea, [{
        key: 'reset',
        value: function reset() {
          this.value_ = '';
          this.mutate('changeInput');
        }
      }, {
        key: 'setValueFromRealNode',
        value: function setValueFromRealNode(realNode) {
          this.value = realNode.value;
        }
      }, {
        key: 'setValue',
        value: function setValue(value) {
          this.value_ = String(value);
          this.mutate('changeInput');
        }
      }]);

      return Textarea;
    }(Element);

    ;

    Object.defineProperty(Textarea.prototype, 'value', {
      get: function get() {
        return this.value_;
      },
      set: function set(value) {
        return this.setValue(value);
      },
      configurable: true,
      enumerable: true
    });

    return Textarea;
  }();
}).call(undefined);