'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _global = require('../core/global');

var _global2 = _interopRequireDefault(_global);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Map;

module.exports = _global2.default.Map || (Map = function () {
  function Map() {
    _classCallCheck(this, Map);

    this.keys = [];
    this.values = [];
    return;
  }

  _createClass(Map, [{
    key: 'get',
    value: function get(key) {
      var index;
      index = this.keys.indexOf(key);
      return this.values[index];
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      var index;
      index = this.keys.indexOf(key);
      if (index !== -1) {
        this.values[index] = value;
      } else {
        this.keys.push(key);
        this.values.push(value);
      }
      return value;
    }
  }, {
    key: 'has',
    value: function has(key) {
      var index;
      index = this.keys.indexOf(key);
      return index !== -1;
    }
  }, {
    key: 'delete',
    value: function _delete(key) {
      var index;
      index = this.keys.indexOf(key);
      if (index !== -1) {
        this.keys.splice(index, 1);
        this.values.splice(index, 1);
      }
    }
  }]);

  return Map;
}());