'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Context;

  module.exports = Context = function () {
    var wrapperSymbol;

    var Context = function () {
      _createClass(Context, null, [{
        key: 'destroy',
        value: function destroy(handler) {
          if (!this.active) {
            return;
          }
          if (!handler) {
            return;
          }
          this.active.destroy(handler);
        }
      }, {
        key: 'wrap',
        value: function wrap(func) {
          var context, wrapper;
          if (func[wrapperSymbol]) {
            return func[wrapperSymbol];
          }
          context = this.active;
          wrapper = function wrapper() {
            if (context) {
              return context.apply(func, arguments, this);
            } else {
              return func.apply(this, arguments);
            }
          };
          func[wrapperSymbol] = wrapper;
          return wrapper;
        }
      }]);

      function Context(target) {
        _classCallCheck(this, Context);

        this.target = target;
        this.handlers = [];
        this.old = null;
        return;
      }

      _createClass(Context, [{
        key: 'destroy',
        value: function destroy(handler) {
          var i, len, ref;
          if (handler) {
            this.handlers.push(handler);
          } else {
            ref = this.handlers;
            for (i = 0, len = ref.length; i < len; i++) {
              handler = ref[i];
              handler();
            }
          }
        }
      }, {
        key: 'activate',
        value: function activate() {
          this.old = Context.active;
          Context.active = this;
        }
      }, {
        key: 'deactivate',
        value: function deactivate() {
          Context.active = this.old;
        }
      }, {
        key: 'apply',
        value: function apply(func, args) {
          var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

          var old, result;
          old = Context.active;
          Context.active = this;
          result = func.apply(context, args);
          Context.active = old;
          return result;
        }
      }]);

      return Context;
    }();

    ;

    wrapperSymbol = Symbol('wrapper');

    Context.active = null;

    return Context;
  }();
}).call(undefined);