'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Event;

  module.exports = Event = function () {
    var Event = function () {
      _createClass(Event, null, [{
        key: 'emit',
        value: function emit(name, src, target, realEvent) {
          var event;
          event = new Event(name, src, target, realEvent);
          event.emit();
          return event;
        }
      }]);

      function Event(name1, src1, target1, realEvent1) {
        _classCallCheck(this, Event);

        this.updateLayer = this.updateLayer.bind(this);
        this.name = name1;
        this.src = src1;
        this.target = target1;
        this.realEvent = realEvent1;
        this.clientX = this.realEvent.clientX;
        this.clientY = this.realEvent.clientY;
        this._layerX = 0;
        this._layerY = 0;
        this._layerUpdated = false;
        this.own = this.src === this.target;
        this.prevented = false;
        this.stopped = false;
        return;
      }

      _createClass(Event, [{
        key: 'updateLayer',
        value: function updateLayer(type) {
          var rect;
          if (this._layerUpdated) {
            return;
          }
          rect = this.target.rect();
          this._layerX = this.clientX - rect.left;
          this._layerY = this.clientY - rect.top;
          this._layerUpdated = true;
        }
      }, {
        key: 'emit',
        value: function emit() {
          Event.target = this.target;
          this.target.emit(this.name, this);
          Event.target = null;
          return this;
        }
      }, {
        key: 'prevent',
        value: function prevent() {
          this.prevented = true;
        }
      }, {
        key: 'stop',
        value: function stop() {
          this.stopped = true;
        }
      }]);

      return Event;
    }();

    ;

    Event.target = null;

    Object.defineProperty(Event.prototype, 'layerX', {
      get: function get() {
        this.updateLayer();
        return this._layerX;
      }
    });

    Object.defineProperty(Event.prototype, 'layerY', {
      get: function get() {
        this.updateLayer();
        return this._layerY;
      }
    });

    return Event;
  }();
}).call(undefined);