'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _element = require('./element');

var _element2 = _interopRequireDefault(_element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select;

module.exports = Select = function () {
  var Select = function (_Element) {
    _inherits(Select, _Element);

    function Select() {
      _classCallCheck(this, Select);

      var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).apply(this, arguments));

      _this.index_ = 0;
      _this.option = null;
      return _possibleConstructorReturn(_this);
    }

    _createClass(Select, [{
      key: 'setIndex',
      value: function setIndex(index) {
        this.index_ = index;
        this.mutate('changeInput');
      }
    }, {
      key: 'reset',
      value: function reset() {
        this.index = 0;
      }
    }, {
      key: 'getOptions',
      value: function getOptions() {
        var i, len, options, realOption, ref;
        options = [];
        ref = this.realNode.options;
        for (i = 0, len = ref.length; i < len; i++) {
          realOption = ref[i];
          options.push(ui.getVirtualNode(realOption));
        }
        return options;
      }
    }, {
      key: 'setValueFromRealNode',
      value: function setValueFromRealNode(realNode) {
        this.index = realNode.selectedIndex;
        this.option = ui.getVirtualNode(realNode.options[realNode.selectedIndex]);
      }
    }]);

    return Select;
  }(_element2.default);

  ;

  Object.defineProperty(Select.prototype, 'index', {
    configurable: true,
    enumerable: true,
    get: function get() {
      return this.index_;
    },
    set: function set(index) {
      return this.setIndex(index);
    }
  });

  return Select;
}();