'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _global = require('../core/global');

var _global2 = _interopRequireDefault(_global);

var _context = require('../core/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Frame, cancelAnimationFrame, requestAnimationFrame;

requestAnimationFrame = _global2.default.requestAnimationFrame || _global2.default.webkitRequestAnimationFrame || _global2.default.mozRequestAnimationFrame || _global2.default.oRequestAnimationFrame || _global2.default.oRequestAnimationFrame || function (callback) {
  return setTimeout(callback, 1000 / 60);
};

cancelAnimationFrame = _global2.default.cancelAnimationFrame || _global2.default.webkitCancelAnimationFrame || _global2.default.mozCancelAnimationFrame || _global2.default.oCancelAnimationFrame || _global2.default.msCancelAnimationFrame || function (id) {
  return _global2.default.clearTimeout(id);
};

Frame = function () {
  function Frame(handler) {
    var _this = this;

    _classCallCheck(this, Frame);

    this.id = requestAnimationFrame(_context2.default.wrap(handler));
    _context2.default.destroy(function () {
      return _this.stop();
    });
    return;
  }

  _createClass(Frame, [{
    key: 'stop',
    value: function stop() {
      cancelAnimationFrame(this.id);
    }
  }]);

  return Frame;
}();

module.exports = function (handler) {
  return new Frame(handler);
};