'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _context = require('../core/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Timeout;

Timeout = function () {
  function Timeout(handler, time) {
    var _this = this;

    _classCallCheck(this, Timeout);

    if (typeof time === 'function') {
      var _ref = [handler, time];
      time = _ref[0];
      handler = _ref[1];
    }
    this.id = setTimeout(_context2.default.wrap(handler), time);
    _context2.default.destroy(function () {
      return _this.stop();
    });
    return;
  }

  _createClass(Timeout, [{
    key: 'stop',
    value: function stop() {
      clearTimeout(this.id);
    }
  }]);

  return Timeout;
}();

module.exports = function (handler, time) {
  return new Timeout(handler, time);
};